version: "3.7"

services:
  app:
    image: node:15-slim
    user: ${UID:-0}:${GID:-0}
    command: bash -c "yarn && yarn serve"
    stdin_open: true
    tty: true
    working_dir: /app
    environment:
      - PROJECT_URL
      - "DOCS_URL=docs-${PROJECT_URL}"
      - YARN_CACHE_FOLDER=/cache
    expose:
      - "8080"
    volumes:
      - ".:/app"
      - "$HOME/.cache/yarn:/cache"
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=localhost_default"
      - "traefik.http.routers.${PROJECT_NAME}.rule=Host(`${PROJECT_URL}`)"
      - "traefik.http.routers.${PROJECT_NAME}.entrypoints=websecure"
      - "traefik.http.routers.${PROJECT_NAME}.middlewares=hsts@file"
      - "traefik.http.routers.${PROJECT_NAME}.tls=true"
    networks:
      - default
      - localhost_default
    deploy:
      resources:
        limits:
          memory: 4g

  vue:
    image: savadenn/vue
    user: ${UID:-0}:${GID:-0}
    command: vue --version
    working_dir: /app
    volumes:
      - ".:/app"
      - "./.vuerc:/home/node/.vuerc"

  doc:
    image: savadenn/pandoc:latest
    user: ${UID:-0}:${GID:-0}
    restart: unless-stopped
    stdin_open: true
    tty: true
    labels:
      - "traefik.enable=true"
      - "traefik.docker.network=localhost_default"
      - "traefik.http.routers.docs-${PROJECT_NAME}.rule=Host(`docs-${PROJECT_URL}`)"
      - "traefik.http.routers.docs-${PROJECT_NAME}.entrypoints=websecure"
      - "traefik.http.routers.docs-${PROJECT_NAME}.middlewares=hsts@file"
      - "traefik.http.routers.docs-${PROJECT_NAME}.tls=true"
    environment:
      LANG: fr_FR.UTF-8
      SPI_WATCH: "true"
      SPI_FORMAT: "html"
    volumes:
      - "./docs:/data"
      - "./dist/docs:/public"
    networks:
      - localhost_default

networks:
  localhost_default:
    external:
      name: localhost_default
